#include "CoreSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{

    Commit CoreSegment::toCommit() const
    {
        Commit c;
        for (const auto& [k, s] : _container)
        {
            c.append(s.toCommit());
        }
        return c;
    }

    void CoreSegment::_copySelfWithoutData(CoreSegment& other) const
    {
        other.id() = _id;
        other.setMaxHistorySize(_maxHistorySize);
        for (const auto& [k, s] : _container)
        {
            other.addProviderSegment(s.copyWithoutData());
        }
    }
}
