#include "Entity.h"

namespace armarx::armem::wm
{

    Commit Entity::toCommit() const
    {
        Commit c;
        for (const auto& [k, s] : _container)
        {
            EntityUpdate& up = c.add();
            up.entityID = id();
            up.timeCreated = k;
            up.instancesData = s.getAronData();
        }
        return c;
    }

    void Entity::_copySelfWithoutData(Entity& other) const
    {
        other.id() = _id;
        other.setMaxHistorySize(_maxHistorySize);
        for (const auto& [k, s] : _container)
        {
            other.addSnapshot(s.copyWithoutData());
        }
    }
}
